package com.reportmill.webobjects;
import com.reportmill.foundation.*;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;

public class RMCSVPage extends WOComponent {
    public RMDocument   document;
    public String       filename = "report.csv"; // Optional filename for "Content-Disposition"

public RMCSVPage(WOContext context) { super(context); }

public void appendToResponse(WOResponse aResponse, WOContext aContext)
{
    // Get bytes, configure headers and set content
    byte data[] = document.csvBytes();      
    aResponse.setHeader("text/csv", "content-type");
    aResponse.setHeader("inline; filename=\"" + filename + "\"", "content-disposition");
    aResponse.setHeader("" + data.length, "Content-length");
    aResponse.setContent(new NSData(data));
}

// Loads .wo (.html & .wod) from Strings in subclasses (override html() and wod() to change)
public WOElement template() { return templateWithHTMLString("<HTML></HTML>", "\n", null); }

}
