package com.reportmill.webobjects;
import com.reportmill.foundation.*;
import com.reportmill.shape.*;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import java.io.*;

public class RMFlashPage extends WOComponent {
    public RMDocument   document;
    public String       filename = "report.swf"; // Optional filename for "Content-Disposition"
    public WOResponse   dataResponse;
    public float        width, height;
    public boolean      shouldLoop;

public RMFlashPage(WOContext context) { super(context); }

public void appendToResponse(WOResponse aResponse, WOContext aContext)
{
    byte data[] = document.flashBytes();
    RMPage firstPage = document.getPage(0);
    width = firstPage.getWidth();
    height = firstPage.getHeight();
    shouldLoop = document.getAnimatorLast()==null? false : document.getAnimatorLast().getLoops();
      
    // Get response and configure headers
    dataResponse = new WOResponse();
    dataResponse.setHeader("application/x-shockwave-flash", "content-type");
    dataResponse.setHeader("inline; filename=\"" + filename + "\"", "content-disposition");
    dataResponse.setHeader("" + data.length, "Content-length");

    // Set data
    dataResponse.setContent(new NSData(data));

    super.appendToResponse(aResponse, aContext);
}

/** Load template from Strings instead of .wo file. */
public WOElement template() { return templateWithHTMLString(html(), wod(), null); }

String html()
{
    return
    "<HTML><HEAD><TITLE>Flash Report</TITLE></HEAD>\n" +
    "<BODY><CENTER>\n" + 
    "<WEBOBJECT NAME=RMObject>\n" + 
    "<WEBOBJECT NAME=RMParam></WEBOBJECT>\n" +
    "<WEBOBJECT NAME=RMParam2></WEBOBJECT>\n" +
    "<WEBOBJECT NAME=RMEmbed></WEBOBJECT>\n" +
    "</WEBOBJECT>\n" +
    "</CENTER></BODY></HTML>\n";
}

String wod()
{
    return
    "RMEmbed: WOEmbeddedObject {\n" +
    "    height = height;\n" +
    "    mimeType = \"application/x-shockwave-flash\";\n" +
    "    width = width;\n" +
    "    pluginspage = \"http://www.macromedia.com/shockwave/download/\";\n" +
    "    value = dataResponse;\n" +
    "    loop = shouldLoop;\n" +
    "}\n" +
    "RMObject: WOGenericContainer {\n" +
    "    classid = \"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\";\n" +
    "    codebase = \"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#4,0,0,0\";\n" +
    "    elementName = \"Object\";\n" +
    "    height = height;\n" +
    "    width = width;\n" +
    "    loop = shouldLoop;\n" +
    "}\n" +
    "RMParam: WOParam { action = dataResponse; name = \"MOVIE\"; }\n" +
    "RMParam2: WOParam { name = \"loop\"; value = shouldLoop; }\n";
}

}
