package com.reportmill.webobjects;
import com.reportmill.foundation.*;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import java.io.*;

public class RMPDFPage extends WOComponent {
    public RMDocument   document;
    public String       filename = "report.pdf"; // Optional filename for "Content-Disposition"
    byte                data[];

public RMPDFPage(WOContext context) { super(context); }

public void appendToResponse(WOResponse aResponse, WOContext aContext)
{
    // Generate PDF bytes
    if(data==null) {
        data = document.pdfBytes();
        if(ieWorkAround(aResponse, aContext)) return; // IE POST bug workaround
    }

    // If not IE, just return the pdf data
    aResponse.setHeader("application/pdf", "Content-Type");
    aResponse.setHeader("inline; filename=\"" + filename + "\"", "content-disposition");
    aResponse.setHeader("" + data.length, "Content-length");
    aResponse.setContent(new NSData(data));
}

// For IE workaround
public RMPDFPage ieWorkAroundPage;
boolean ieWorkAround(WOResponse aResponse, WOContext aContext)
{
    String br = aContext.request().headerForKey("user-agent");
    boolean ie = br.startsWith("Mozilla/2.0 (compatible; MSIE");
    //ie = ie || br.startsWith("Mozilla/4.0 (compatible; MSIE"); // Not sure of all the broken versions
    if(ie) {
        ieWorkAroundPage = (RMPDFPage)pageWithName("RMPDFPage");
        ieWorkAroundPage.data = data;
        data = null;
        super.appendToResponse(aResponse, aContext);
        return true;
    }
    return false;
}

/** Load template from Strings instead of .wo file. */
public WOElement template() { return templateWithHTMLString(html(), wod(), null); }
String wod() { return "RMIEFRAME: WOFrame {\n\tvalue=ieWorkAroundPage;\n}\n"; }
String html() {
    return "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n" +
    "<HTML><HEAD></HEAD>\n" + 
    "<FRAMESET>\n" + 
    "<WEBOBJECT NAME=\"RMIEFRAME\"></WEBOBJECT>\n" +
    "</FRAMESET></HTML>";
}

}
