package com.reportmill.webobjects;
import com.webobjects.foundation.*;
import com.webobjects.appserver.*;
import com.reportmill.foundation.*;

/**
 * This RMDocument subclass simply supports an additional source type in its constructor: a simple name, which it
 * uses in conjunction with the WOResourceManager.pathForResourceNamed() to evaluate to a template path.
 */
public class RMWODocument extends RMDocument {

/** This static initializer installs the RMWebObjects convertFromAppServerType hook. */
static { RMWebObjects.setAppServer(); }

/**
 * Creates a WODocument instance from aSource.
 */
public RMWODocument(Object aSource)
{
    super(evalPath(aSource));
}

/**
 * This method uses the WOResourceManager to evaluate names.
 */
public static Object evalPath(Object aSource)
{
    String path = aSource instanceof String? aSource.toString() : null;
    
    if(path!=null && !path.endsWith(".rpt")) {
        WOResourceManager manager = WOApplication.application().resourceManager();
        aSource = manager.bytesForResourceNamed(path + ".rpt", null, null);
    }
    
    return aSource;
}

}
